<template>
  <div flex="~ col gap-6" items-center w="full">

    <code>{{ uuid }}</code> <!-- TODO: for devs only? -->

    <h3 v-if="error" text="lg center red-600">{{ error }}</h3>
    <template v-else>
      <div flex="~ col" items-center w-full gap-2>
        <h3 text-center>
          <span font-semibold>Block Share URL</span>
          <span v-if="!copied"> (click field below to copy)</span>
          <span v-else text="green-500" font-semibold> Copied ✔</span>
        </h3>
        <input ref="shareFieldRef" @click="selectContents" v-model="shareUrl" block w-full p="2"
          border="2 rounded-lg purple-500" overflow="scroll" font-mono />
      </div>
    </template>
  </div>
</template>

<script setup lang="ts">
import { computed, ref, watch } from 'vue'
import { Logger } from 'logger'
const { ERROR, WARN, LOG, DEBUG, VERBOSE } = Logger.setup(Logger.DEBUG, { performanceEnabled: true }) // eslint-disable-line @typescript-eslint/no-unused-vars

const { uuid, publicationHash } = $defineProps<{
  uuid: string,
  publicationHash: string
}>()
const shareFieldRef = ref<HTMLInputElement | null>(null)

const copied = ref(false)

const error = computed(() => {
  if (!publicationHash) return "Publication not initialized, cannot share"
})

const selectContents = () => {
  DEBUG("select from:", shareFieldRef, shareFieldRef?.value)

  if (shareFieldRef) {
    shareFieldRef.value?.select()
    let result = document.execCommand("copy")
    DEBUG("RESULT: ", result)
    copied.value = result
  }
}
// watch(shareFieldRef, () => {
//   selectContents()
// })
const shareUrl = computed(() => {
  DEBUG('button share URL?', { uuid, publicationHash })
  const bygonzShareURL = `logseq://bygonz/open?pub=${publicationHash}&block=${uuid}`
  DEBUG('button share URL:', bygonzShareURL)
  return bygonzShareURL
})
</script>
